/*
Copyright (c) 1998-2009 VIA Technologies, Inc. All Rights Reserved.
 
This PROPRIETARY SOURCE CODE contains proprietary information of VIA 
Technologies, Inc. (VIA); Contents of this file shall not be disclosed to any 3rd party, 
copied or duplicated in any form, in whole or in part without prior written consent of 
VIA.  THIS SOURCE CODE & ANY RELATED DOCUMENTATION 
(COLLECTIVELY SOFTWARE) ARE PROVIDED AS IS, WITH ALL FAULTS, & 
WITHOUT WARRANTY OF ANY KIND.  VIA DISCLAIMS ALL EXPRESS OR 
IMPLIED WARRANTIES.  USER ACKNOWLEDGES THAT PARTIES FOR ANY 
DAMAGES ARISING FROM USE OF SOFTWARE OR ITS DERIVATIVE, 
INCLUDING, W/O LIMITATION, LOSS OF USE, DATA OR PROFITS. USER
WHOLLY ASSUMES ALL RISK ARISING FROM USE & PERFORMANCE OF 
SOFTWARE
*/ 
 
#ifndef FDAPI_CPU_H_
#define FDAPI_CPU_H_

#include "fdapi_base.h"

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************
  CPU info
************************************************************************/
#pragma pack(1)
/**
 * The structure defined below can be used to get the CPU information.
 *
 */
typedef struct
{
	/// TCHAR is the sam as char on Windows XP and linux.
	/// TCHAR is the sam as wchar_t on Windows CE.
	TCHAR	szName[64];      ///< processor name
	TCHAR	szPackage[32];   ///< BGA package
	double	dbSpeed;       ///< unit: MHz
	BYTE	byFamily;        ///< family ID
	BYTE	byModel;         ///< model ID
	BYTE	byStepping;      ///< stepping ID
} TFDCpuInfo, *PTFDCpuInfo;
#pragma pack()

/**
 * Get the CPU information.
 * @param ptCpuInfo: a pointer to a TFDCpuInfo structure that receives the CPU information.
 * @return   :
 * FD_S_OK: The function is success.
 * FD_E_INVALID_ARG: ptCpuInfo is NULL.
 * FD_E_FAIL: The function fails.
 */
FLITEDECK_API DWORD FDCpu_GetInfo(PTFDCpuInfo ptCpuInfo);


#ifdef __cplusplus
} // extern C
#endif

#endif
